/*  Submarino
 *
 * Copyright  Rafael Losada, 2002. 
 */

import java.applet.*; import java.lang.*; import java.awt.*; import java.awt.event.*;
import java.applet.Applet; import java.net.MalformedURLException; import java.net.URL;

public class submar extends Applet implements ItemListener {

     	String F, NUM;
	Choice zverti; 
	int VX, VY, ALTO, vx, vy, lc,lf, bc,bf,df,dc,d,d2f,d2c,d2, q,q2, fin, M, TAM;
	Font Fuente0, Fuente1, Fuente2, Fuente3; 
	Color enc, fnd, fnd2, verde, ciano, lila, rojo, azul, azul2, grana;

	public void init() {
		Fuente0=new Font("Arial",Font.PLAIN,14); Fuente1=new Font("Arial",Font.PLAIN,12);
		Fuente2=new Font("Arial",Font.PLAIN,9); Fuente3=new Font("Arial",Font.PLAIN,11);
      	fin=0; M=10; TAM=200/M;  
		vvxy(); iniciales(); 
		apagar(); update(getGraphics()); dibujaTablero(getGraphics());
		setLayout(new FlowLayout(0));
		zverti=new Choice();
          	for (int i=10; i<26; i++) zverti.addItem(Integer.toString(i));
		zverti.select("10"); add(zverti);
		enc=new Color(250,250,200); fnd=new Color(146,177,192);
		fnd2=new Color(206,217,232); verde=new Color(0,150,120);
		grana=new Color(220,0,0); ciano=new Color(0,200,200); 
		lila=new Color(200,0,200); rojo=new Color(200,0,0); 
		azul=new Color(0,0,200); azul2=new Color(0,120,150);
		zverti.addItemListener(this);	
     	}

	void iniciales() {
		F="FELICIDADES"; 
	}

	void inicio() {
		Fuente0=new Font("Arial",Font.PLAIN,14); Fuente1=new Font("Arial",Font.PLAIN,12);
		Fuente2=new Font("Arial",Font.PLAIN,9); Fuente3=new Font("Arial",Font.PLAIN,11);
      	fin=0; TAM=200/M; vvxy(); 
		apagar(); dibujaTablero(getGraphics()); update(getGraphics()); 
	}

	public void apagar(){
          	lf=-1; lc=-1;
		bf=(int)Math.floor(M*Math.random()); bc=(int)Math.floor(M*Math.random()); 
	}

	public void start() {
          setBackground(fnd); inicio();
     	}

	public void refresca(Graphics g) {
		g.setColor(fnd); g.fillRect(0,0,562,252); dibujaTablero(getGraphics());
	}

	public void paint(Graphics g) {
		update(g); dibujaTablero(g);
	}

     	public void update(Graphics g) {
         	g.setColor(grana); g.fill3DRect(150,5,30,20,true);
		g.setColor(Color.white); g.fillRect(160,10,10,10);
		g.setFont(Fuente0); g.setColor(Color.yellow); g.drawString("",195,15);
		for (int i=0; i<M; i++) {
               	for (int j=0; j<M; j++) ponLuzSombra(i,j,g); 
          	}
		int k=0;
		if (lf==bf && lc==bc) fin=1;
		if (fin==1) {
			g.setColor(enc); g.fillRect(48,5,100,20);
			for (int j=1; j<100; j++) {
				for (int i=1; i<200; i++) {
					g.setColor(Color.red); g.drawString(F,52,20);
          				g.setColor(grana); g.drawString(F,51,21);
				}
				for (int i=1; i<20; i++) {
					g.setColor(Color.white); g.drawString(F,52,20);
          				g.setColor(grana); g.drawString(F,51,21);
				}
			}
			g.setFont(Fuente1);
		} else {
			g.setColor(Color.white); g.drawString("SUBMARINO", 56,20);
		}
	}

     	public void dibujaTablero(Graphics g) {
		vvxy(); g.setColor(Color.black);
          	g.drawLine(VX,VY,VX,VY+ALTO); g.drawLine(VX+ALTO,VY,VX+ALTO,VY+ALTO);
		for (int i=1; i<M; i++) g.drawLine(VX+ALTO*i/M,VY,VX+ALTO*i/M,VY+ALTO);
          	g.drawLine(VX,VY,VX+ALTO,VY); g.drawLine(VX,VY+ALTO,VX+ALTO,VY+ALTO);
          	for (int j=1; j<M; j++) g.drawLine(VX,VY+ALTO*j/M,VX+ALTO,VY+ALTO*j/M);
		g.setColor(Color.black);
     	}
	
	public void vvxy() {
		ALTO=TAM*M; VX=5+(200-ALTO)/2; VY=5+(260-ALTO)/2;
	}

     	public void ponLuzSombra(int columna, int fila, Graphics g) {
		vvxy(); vx=VX+columna*TAM; vy=VY+fila*TAM;
		df=Math.abs(bf-lf); dc=Math.abs(bc-lc); d=df*df+dc*dc;
		d2f=Math.abs(fila-lf); d2c=Math.abs(columna-lc); d2=d2f*d2f+d2c*d2c;
		g.setColor(ciano);
		if (d<16 && d2<16) g.setColor(Color.green);
		if (d<9 && d2<9) g.setColor(Color.yellow);
		if (d<3 && d2<3) g.setColor(Color.red);
		if (d==0 && d2==0) g.setColor(Color.white);
          	g.fillRect(VX+columna*TAM+2,VY+fila*TAM+2,TAM-2,TAM-2);
     	}

     	public boolean mouseUp(Event event, int x, int y) {
	     	if (fin==1) {
               refresca(getGraphics()); inicio(); update(getGraphics());
          	} else {
			if (x>149 && x<181 && y>4 && y<26){
               		refresca(getGraphics()); inicio(); update(getGraphics());
			}
            	if(x>190 && y<20){
                		try {
                    		URL url = new URL("http://www.anarkasis.com/rafa/");
                    		AppletContext appletcontext = getAppletContext();
                    		appletcontext.showDocument(url, "_blank");
                		}
                		catch(MalformedURLException malformedurlexception) { }
           		 }
			vvxy(); lc=(x-VX)/TAM; lf=(y-VY)/TAM;
			q=0; q2=0;
			while (q!=0 || q2!=0) {
				q=(int)Math.floor(3*Math.random())-1;
				q2=(int)Math.floor(3*Math.random())-1;
			} 
			if (bf+q>-1 && bf+q<M) bf=bf+q;
			else bf=bf-q;
			if (bc+q2>-1 && bc+q2<M) bc=bc+q2;
			else bc=bc-q2;
               	update(getGraphics());
          	}
          	return true;
     	}

     	public void itemStateChanged(ItemEvent e) {
		if (e.getItemSelectable()==zverti) M=zverti.getSelectedIndex()+10;
            refresca(getGraphics()); inicio(); 
		vvxy(); refresca(getGraphics()); dibujaTablero(getGraphics()); update(getGraphics());
     	}

}

